--- ./modules/mod_ls.c	2007-09-28 04:53:59.000000000 +0400
+++ ./modules/mod_ls.c	2008-03-17 03:03:35.000000000 +0300
@@ -244,6 +244,8 @@
   return res;
 }
 
+extern char* local2remote(char*);
+
 /* sendline() now has an internal buffer, to help speed up LIST output. */
 static int sendline(int flags, char *fmt, ...) {
   static char listbuf[PR_TUNABLE_BUFFER_SIZE] = {'\0'};
@@ -251,6 +253,7 @@
   char buf[PR_TUNABLE_BUFFER_SIZE+1] = {'\0'};
   int res = 0;
 
+
   if (flags & LS_SENDLINE_FL_FLUSH) {
     size_t listbuflen = strlen(listbuf);
 
@@ -271,9 +274,17 @@
   va_start(msg, fmt);
   vsnprintf(buf, sizeof(buf), fmt, msg);
   va_end(msg);
+  char* buf2;
 
   buf[sizeof(buf)-1] = '\0';
 
+  if (buf[0]) {
+    buf2 = local2remote(buf);
+    if (buf2) {
+      strcpy(buf, buf2); free(buf2);
+    }
+  }
+
   /* If buf won't fit completely into listbuf, flush listbuf */
   if (strlen(buf) >= (sizeof(listbuf) - strlen(listbuf))) {
     res = pr_data_xfer(listbuf, strlen(listbuf));
